
;------ macros ------
waitb	macro
	btst	#6,(a5)
.wait\@	btst	#6,(a5)
	bne.s	.wait\@
	endm

waittof	macro
.tof\@	btst	#5,$1d(a5)
	beq.s	.tof\@
	move	#32,$9a(a5)
	endm

;------ code ------

	SECTION code,CODE_P
	
j:	bsr	init1
	bsr	precalcs

mouse:	tst.b	12(a4)
	beq.s	.mouse
	clr.b	12(a4)
	bsr	test
	bsr	place
	clr	60(a4)
;	move	#$55,$17e(a5)
.mouse	btst	#6,$bfe001
	bne.s	mouse

	bra	init2

Interrupt:
	btst	#5,$1d(a5)
	beq.s	.novert
	movem.l	d0-d7/a0-a6,-(sp)
	bsr	bcopy
	bsr	np_music
	movem.l	(sp)+,d0-d7/a0-a6
	tst	80(a4)
	beq.s	.jump2
	subq	#1,80(a4)
	bne.s	.jump
	bsr	clean2
	bra.s	.jump
.jump2	tst	60(a4)
	bne	.jump
	movem.l	d0-d7/a0-a6,-(sp)
	bsr	swapscreen
	bsr	plot
	movem.l	(sp)+,d0-d7/a0-a6
.jump	move	#32,$9a(a5)
.novert	rte

precalcs:
	lea	blane2+2,a0
	lea	second,a1
	move.l	a1,d1
	move	d1,4(a0)
	swap	d1
	move	d1,0(a0)
	lea	chess,a0
	moveq	#-1,d0
	moveq	#3,d5
.loop4	moveq	#31,d6
.loop5	move	#13,d7
.loop2	move.l	d0,(a0)+
	not.l	d0
	dbf	d7,.loop2
	dbf	d6,.loop5
	not.l	d0
	dbf	d5,.loop4
	bsr	place
	bsr	test
	rts

swapscreen:
	move.l	42(a4),d0
	move.l	46(a4),d1
	move.l	d0,46(a4)
	move.l	d1,42(a4)
	lea	blane+2,a0
	move	d1,4(a0)
	swap	d1
	move	d1,0(a0)
	waitb
	move.l	#-1,$42(a5)
	move	#0,$64(a5)
	move.l	#$1000000,$3e(a5)
	move.l	d0,$52(a5)
	move	#[64*280]+22,$56(a5)
	waitb
	rts
place:
	lea	xtable(pc),a0
	lea	512(a0),a1
	lea	tempcoords(pc),a2
	move	#1400,d2
.loop	move	62(a4),d0
	move	64(a4),d1
	add	#10,d0
	add	#4,d1
	and	#510,d1
	and	#510,d0
	movem	d0/d1,62(a4)
	move	0(a0,d0.w),(a2)+
	move	0(a1,d1.w),(a2)+
	dbf	d2,.loop
	rts

clean2:
	move.l	a0,-(sp)
	waitb
	lea	second,a0
	move.l	a0,$52(a5)
	move.l	#-1,$42(a5)
	move	#0,$64(a5)
	move.l	#$1000000,$3e(a5)
	move	#[64*168]+22,$56(a5)
	waitb
	move.l	(sp)+,a0
	rts

test:	moveq	#0,d0		
	moveq	#9-1,d2		
	moveq	#7-1,d4		
	moveq	#40-1,d5
	lea	xycoords(pc),a1	
	move.l	66(a4),a2
	tst.b	(a2)
	bpl.s	.jump3
	move	#5*50,80(a4)
	tst.b	1(a2)
	bpl.s	.nr
	lea	text-1(pc),a2
.nr	addq.l	#1,a2
.jump3	lea	1(a2),a3
	moveq	#-8,d1
.loop4	addq	#8,d1
	tst.b	(a3)+
	bne.s	.loop4
	move	#351,d0
	sub	d1,d0
	lsr	#1,d0
	lea	chartable(pc),a3
	move.b	(a2)+,d1
	ext	d1
	move	d1,d6
	lsl	#3,d1
	add	d6,d1
	add	#55,d1
.loop2	moveq	#0,d6
	move.b	(a2)+,d6
	beq.s	.end
	sub.b	#32,d6
	bne.s	.nspace
	addq	#8,d0
	bra.s	.loop2
.nspace	add	d6,d6
	move	0(a3,d6.w),d6
	ext.l	d6
	lea	fonts,a0
	add.l	d6,a0
	moveq	#7,d3
.loop	btst	d3,(a0)
	beq.s	.npoint
	move	d0,(a1)+
	move	d1,(a1)+
.npoint	addq	#1,d1
	lea	78(a0),a0
	dbf	d2,.loop	
	subq	#1,d3
	sub	#9,d1
	addq	#1,d0
	moveq	#9-1,d2
	lea	-9*78(a0),a0
	dbf	d4,.loop
	moveq	#6,d4
	addq	#1,d0
	dbf	d5,.loop2
.end	move.l	a2,66(a4)
	move	#'TT',(a1)
	rts

bcopy:
	move.l	34(a4),d0
	move.l	38(a4),d1
	move.l	d1,34(a4)
	move.l	d0,38(a4)
	addq.l	#2,d1
	lea	plane1+2,a0
	lea	plane2+2,a1
	lea	plane3+2,a2
	lea	plane4+2,a3
	lea	plane5+2,a6
	move	d1,4(a0)
	move	d1,4(a1)
	move	d1,4(a2)
	move	d1,4(a3)
	move	d1,4(a6)
	swap	d1
	move	d1,(a0)
	move	d1,(a1)
	move	d1,(a2)
	move	d1,(a3)
	move	d1,(a6)

	lea	mdata(pc),a0
	move	70(a4),d2
	addq	#4,d2
	and	#$1fe,d2
	move	d2,70(a4)
	move	0(a0,d2.w),d3
	asr	#6,d3
	add	#$20,d3
	add	#128,d2
	and	#$1fe,d2
	move	0(a0,d2.w),d1
	asr	#6,d1
	add	#$10,d1
	move	72(a4),d2
	add	d1,d2
	and	#$1fff,d2
	move	d2,72(a4)
	move	74(a4),d1
	add	d3,d1
	and	#$1fff,d1
	move	d1,74(a4)
	lsr	#7,d2
	lsr	#7,d1
	moveq	#63,d3
	and	d3,d1
	and	d3,d2
	mulu	#56,d2
	moveq	#-10,d3
	and	d1,d3
	lsr	#3,d3
	add	d3,d2
	moveq	#15,d3
	and	d3,d1
	sub	d1,d3
	ror	#4,d3
	or	#$9f0,d3	
	swap	d3
	ext.l	d2
	lea	chess+4,a0
	add.l	d2,a0
	waitb
	move.l	a0,$4e(a5)
	move.l	d0,$52(a5)
	move.l	#-1,$42(a5)
	move.l	d3,$3e(a5)
	move.l	#$80000,$62(a5)
	move	#[64*64]+24,$56(a5)
	rts


plot:
	lea	xycoords-4(pc),a0
	lea	tempcoords(pc),a3
	move.l	46(a4),a1
	lea	second,a2
	move	58(a4),d4
	moveq	#0,d3
.loop2	addq.l	#4,a0
.loop	move	(a3)+,d5
	move	(a3)+,d6
	bmi	.loop2
	move	(a0)+,d0
	move	(a0)+,d1
	cmp	#'TT',d0
	beq	.end
	move	#-2,d7
	moveq	#1,d3
	sub	d5,d0
	blt	.sub1
	beq.s	.same1
	addq	#1,d5
.sub1	asr	#4,d0
	add	d0,d5
	bra.s	.back1
.same1	addq	#1,d7
.back1	sub	d6,d1
	blt	.sub2
	beq.s	.same2
	addq	#1,d6
.sub2	asr	#4,d1
	add	d1,d6
	bra.s	.back2
.same2	addq	#1,d7
.back2	move	d5,-4(a3)
	move	d6,-2(a3)
	move	d5,d0
	move	d6,d1
	mulu	#44,d1
	move	d0,d2
	lsr	#3,d0
	add	d0,d1
	not	d2
	and	#7,d2
	bset	d2,0(a1,d1.w)
	tst	d7
	bne.s	.next
	move.l	#-1,-4(a3)
	sub	#44*60,d1
	bset	d2,0(a2,d1.w)
.next	dbf	d4,.loop
	addq	#8,58(a4)
	cmp	#255,58(a4)
	blt.s	.end
	move	#255,58(a4)
.end	tst	d3
	bne.s	.end2
	not.b	12(a4)
	move	#-1,60(a4)
.end2	rts	

;------ initit ------

init1:	lea	store(pc),a4
	lea	$dff002,a5
	suba.l	a6,a6
	clr.l	(a6)+
	move.l	(a6),a6

	jsr	-120(a6)
	
	waittof		;wait	longframe
	waittof		;wait  shortframe

	lea	gfxne(pc),a1
	jsr	-$198(a6)
	move.l	d0,30(a4)
	beq	close

	move	$1a(a5),8(a4)
	move	00(a5),10(a4)
	move	#$7fff,d0
	move	d0,$98(a5)
	move	d0,$9a(a5)
	waitb
	move	d0,$94(a5)
	lea	copperlist,a0
	move.l	a0,$7e(a5)
	move	d0,$86(a5)
	move	#$83c0,$94(a5)
	lea	$bfd100,a6
	move.b	#$81,(a6)
	st	(a6)
	move.l	$6c,(a4)
	lea	interrupt(pc),a0
	move.l	a0,$6c
	bsr	np_init
	move	#$c020,$98(a5)
	rts

init2:	bsr	np_end
	move	#$7fff,d0
	move	d0,$98(a5)
	move	d0,$9a(a5)
	waitb
	move	d0,$94(a5)
	move.l	(a4),$6c
	move	10(a4),d0
	or	#$8000,d0
	move	d0,$94(a5)
	move	8(a4),d0
	or	#$c000,d0
	move	d0,$98(a5)

	move.l	4,a6
	move.l	30(a4),a1
	move.l	$26(a1),$7e(a5)
	move	d0,$86(a5)
	jsr	-$19e(a6)
close:	jsr	-126(a6)
	moveq	#0,d0
	rts
	
	incdir	"df0:"
	include	"sources/mp1.s"

;------ variables ------
	incdir	"df0:others/"
	even
store:	blk.b	13,0
gfxne:	dc.b	'graphics.library',0
	dc.l	0,screen1,screen2,screen3,screen4
	dc.w	0,0,0,0,0,0,0,0
	dc.l	text
	dc.w	0,0,0,0,0,0

xycoords:	blk.w	600*2,0
tempcoords:	blk.w	1400*2,0
xtable:		incbin	"xtable"
ytable:		incbin	"ytable"
mdata:		incbin	"vsin512"
chartable:	dc.w	0,66,0,68,0,0,0,0,75,76,64,62,72,63,71
		dc.w	67,52,53,54,55,56,57,58,59,60,61,70,0,74,65
		dc.w	73,69,0,0,1,2,3,4,5,6,7,8,9,10,11
		dc.w	12,13,14,15,16,17,18,19,20,21,22,23,24,25,0
		dc.w	0,0,77,0,0,26,27,28,29,30,31,32,33,34,35
		dc.w	36,37,38,39,40,41,42,43,44,45,46,47,48,49,50
		dc.w	51,0,0,0,0,0,0,0,0,0,0,0,0,0,0

text:		dc.b	1
		dc.b	'-=) DyNamiX (=-',0
		dc.b	2
		dc.b	'-------------',0
		dc.b	6
		dc.b	'Presents a new crack called',0
		dc.b	8
		dc.b	'-= Stunt Island =-',0
		dc.b	15
		dc.b	'Cracked by The Black Cat!',0,-1

		dc.b	1
		dc.b	'Yo, This is TWL!',0
		dc.b	2
		dc.b	'I would like 2 join 2 the best',0
		dc.b	3
		dc.b	'---> DyNamiX <---',0
		dc.b	5
		dc.b	'Ok here is sum info...',0
		dc.b	6
		dc.b	'Handle: TWL',0
		dc.b	8
		dc.b	'Old groups...PaLaCe, PuNisherS',0
		dc.b	9
		dc.b	'Tarkus Team, Skid Row...',0
		dc.b	11
		dc.b	'Act...: Train, Code, Trade...',0
		dc.b	12
		dc.b	'If u get sum origs for us then',0
		dc.b	13
		dc.b	'it could be cracked too!',0,-1

		dc.b	1
		dc.b	'There will also be a new BBS!',0
		dc.b	2
		dc.b	'BBS will be running on with...:',0
		dc.b	4
		dc.b	'33 Mhz, 500 Megs and 2 or 3 ndz 2',0
		dc.b	5
		dc.b	'move the latest warze from DNX!',0
		dc.b	7
		dc.b	'And if u want I can make also a',0
		dc.b	8
		dc.b	'new sub for us? U know we would',0
		dc.b	9
		dc.b	'get sum intros quite easily',0
		dc.b	11
		dc.b	'U know we can get more coders...',0
		dc.b	13
		dc.b	'If u r intereted then leave a',0
		dc.b	14
		dc.b	'message!',0
		dc.b	16
		dc.b	'Ok Please answer A.S.A.P.!',0,-1

		dc.b	1
		dc.b	'Oops and just a few more bytes 2',0
		dc.b	2
		dc.b	'tell u about my forecomin prods!',0
		dc.b	3
		dc.b	'At the Assembly party (at 30.7)',0
		dc.b	4
		dc.b	'I have made a little party GAME',0
		dc.b	5
		dc.b	'and a DyNamiX intro...',0,-1
		dc.b	7
		dc.b	'Ok ... Be The BEST and FASTEST!',0
		dc.b	9
		dc.b	'DNX-Ur Dream For Tomorrow!',0,-1

		dc.b	2
		dc.b	'Credits:',0
		dc.b	5
		dc.b	'Code - TWL              ',0
		dc.b	7
		dc.b	'Font - Kevin/DMS         ',0
		dc.b	9
		dc.b	'Music - Grim/???         ',0,-1,-1
		even		


	SECTION data,DATA_C

copperList:
	dc.w	$008e,$1a71,$0090,$38d1
	dc.w	$0092,$0030,$0094,$00d8
	dc.w	$0120,$0000,$0122,$0000
	dc.w	$0124,$0000,$0126,$0000
	dc.w	$0128,$0000,$012a,$0000
	dc.w	$012c,$0000,$012e,$0000
	dc.w	$0130,$0000,$0132,$0000
	dc.w	$0134,$0000,$0136,$0000
	dc.w	$0138,$0000,$013a,$0000
	dc.w	$013c,$0000,$013e,$0000
	dc.w	$0100,$0200,$0102,$0000,$0104,$0000
	dc.w	$0108,$0000,$010a,$0004,$0182,$0fff,$0184,$0fff,$186,$fff
	dc.w	$1a07,$fffe,$0180,$0055,$0192,$0088,$0100,$2600
blane:	dc.w	$00e0,$0000,$00e2,$0000
plane1:	dc.w	$00e4,$0000,$00e6,$0000	
	dc.w	$5507,$fffe,$0180,$0000,$0192,$0000
	dc.w	$5607,$fffe,$0180,$0635,$0192,$0857,$0100,$3600
blane2:	dc.w	$00e8,$0000,$00ea,$0000
	dc.w	$5a07,$fffe
plane2:	dc.w	$00e4,$0000,$00e6,$0000
	dc.w	$9a07,$fffe
plane3:	dc.w	$00e4,$0000,$00e6,$0000
	dc.w	$da07,$fffe
plane4:	dc.w	$00e4,$0000,$00e6,$0000
	dc.w	$fe07,$fffe,$0180,$0000,$0192,$0000,$0100,$2600
	dc.w	$ff07,$fffe,$0180,$0236,$0192,$0458
	dc.w	$ffdf,$fffe	;PAL
	dc.w	$1a07,$fffe
plane5:	dc.w	$00e4,$0000,$00e6,$0000
	dc.w	$3707,$fffe,$0100,$0200
	dc.w	$ffff,$fffe,$ffff,$fffe

chess:		blk.b	56*128,0
screen1:	blk.b	48*64,0
screen2:	blk.b	48*64,0
screen3:	blk.b	285*44,0
screen4:	blk.b	285*44,0
second:		blk.b	168*44,0
fonts:		incbin	"fonts.RAW"	
		incdir	"df0:"
np_data:	incbin	"modules/jaba point.grim.np"
